function love.load()
        require "fizzlib"
       -- require "fuzzlib"
		--require "gymnast"
		--require "rubbrman"
		require "vector"
		require "handjob"
		require "garage"
		require "foreplay"
        
		       
        worldSimulate = true
        world = fizz.newWorld(8000, 8000)
        world:setGravity(0, 50)
		
		love.graphics.setBackgroundColor(65, 70, 71)
		--love.graphics.setBackgroundColor(147, 155, 118)
	       
		--Boundary
        testBedWidth = 8000
        w1 = world.newBody(world, 0, 300, 0, 0)
        w2 = world.newBody(world, testBedWidth, 300, 0, 0)
        w3 = world.newBody(world, testBedWidth/2, 600, 0, 0)
        w1:newRectangleShape(0, 0, 10, 600, 0, 0)
        w2:newRectangleShape(0, 0, 10, 600, 0, 0)
        w3:newRectangleShape(0, 0, testBedWidth, 10, 0, 0)
       
		--Vars
		timer = 0
        camX,camY = 0,0
		pCamX, pCamY = 0, 0
		camNumber = 1
		camTarget = false
		camTargets = {}
		camOriginX, camOriginY = 0,0
        camScale = 1
        GuiFocus = false
        focusedBody = false
        mouseprevX, mouseprevY = 0, 0
		vMouseX, vMouseY = love.mouse.getPosition()
		toggleSpriteDrawing = true
		toggleCollisionDrawing = false                                        --<<<<---- Turn off to stop crashing :(
	
		--Vehicle
		car = Garage.newVehicle(100, 200)
		table.insert(camTargets, car.bodies.chassis)
		
		--Player
		player = ForePlay.createCharacter(100, 100, 16, 48)
		table.insert(camTargets, player.body)
		
		camTarget = car.bodies.chassis
	
		tinyFont = love.graphics.newFont(7)
		prevPersonBodyX, prevPersonBodyY = 0,0
		
		joyA, joyB = false, false
		pJoyA, pJoyB = false, false
		
		--Build humps
		rampWidth = 300
		rampHeight = 300
		for i=0, 245, 10 do
			local xx = lengthdir_x(rampWidth, i-90)
			local yy = lengthdir_y(rampHeight, i-90)
			local b = world:newBody( xx+1000, 600+yy-rampHeight, 0, 0)
			b:newRectangleShape(0, 0, rampWidth/5.5, 5, math.rad(-i) )
		end
		
		mJoint = false
end
 
function love.update(dt)
		mouseX, mouseY = love.mouse.getPosition()
		vMouseX, vMouseY = (mouseX-camX)/camScale, (mouseY-camY)/camScale

		if mJoint then
			mJoint.joint:setTarget(vMouseX, vMouseY)
		end

		car:update(dt)
		player:update(dt)
		
        timer = timer + 0.01
              
        if worldSimulate and timer > 0.2 and dt < 0.030 then
               world:update(dt * 4.5)
			   --world:update(0.08)
        end
		
		
		camX, camY = -camTargets[camNumber]:getX()/camScale+400/camScale, -camTargets[camNumber]:getY()/camScale+300/camScale
        if love.mouse.isDown("r") then
                camX = camX - ( mouseprevX - mouseX )
                camY = camY - ( mouseprevY - mouseY )
        end
			
		--Car Control
		if love.keyboard.isDown("right") then
			car.bodies.chassis:applyTorque( 6 )
		end
		
		if love.keyboard.isDown("left") then
			car.bodies.chassis:applyTorque( -6 )
		end
		
		if love.keyboard.isDown("up") then
			car.joints.leftWheelAxel.joint:setMotorSpeed( car.joints.leftWheelAxel.joint:getMotorSpeed() + 50 )
			car.joints.rightWheelAxel.joint:setMotorSpeed( car.joints.rightWheelAxel.joint:getMotorSpeed() + 50 )
		end
		
		if love.keyboard.isDown("down") then
			if car.joints.leftWheelAxel.joint:getMotorSpeed() > 0 then
				car.joints.leftWheelAxel.joint:setMotorSpeed( car.joints.leftWheelAxel.joint:getMotorSpeed() / 3.5 )
				car.joints.rightWheelAxel.joint:setMotorSpeed( car.joints.rightWheelAxel.joint:getMotorSpeed() / 3.5 )
			end
			car.joints.leftWheelAxel.joint:setMotorSpeed( car.joints.leftWheelAxel.joint:getMotorSpeed() - 0.8 )
			car.joints.rightWheelAxel.joint:setMotorSpeed( car.joints.rightWheelAxel.joint:getMotorSpeed() - 0.8 )
		end

		if not love.keyboard.isDown("down") and not love.keyboard.isDown("up") then
			car.joints.leftWheelAxel.joint:setMotorSpeed( 0 )
			car.joints.rightWheelAxel.joint:setMotorSpeed( 0 )
		end
		
		carMaxSpeed = 22
		
		if car.joints.leftWheelAxel.joint:getMotorSpeed() > carMaxSpeed and car.joints.rightWheelAxel.joint:getMotorSpeed() > carMaxSpeed then
			car.joints.leftWheelAxel.joint:setMotorSpeed(carMaxSpeed)
			car.joints.rightWheelAxel.joint:setMotorSpeed(carMaxSpeed)
		end
		
		if car.joints.leftWheelAxel.joint:getMotorSpeed() < -carMaxSpeed and car.joints.rightWheelAxel.joint:getMotorSpeed() < -carMaxSpeed then
			car.joints.leftWheelAxel.joint:setMotorSpeed(-carMaxSpeed)
			car.joints.rightWheelAxel.joint:setMotorSpeed(-carMaxSpeed)
		end
		
        mouseprevX, mouseprevY = mouseX, mouseY
		pJoyStart = joyStart
		pJoyA = joyA
		pJoyB = joyB
		pCamX, pCamY = camX, camY
end
 
function love.draw()
        love.graphics.setCaption("FPS: " .. love.timer.getFPS() )
        love.graphics.print("Cam-x: " .. -camX .. "\nCam-y: " .. -camY .. "\nCamScale: " .. camScale .. "\nWorld Simulate: " .. tostring(worldSimulate), 0, 600-60)
		love.graphics.print("Mjoint: " .. tostring(mJoint), 20, 20)
		love.graphics.print("BodyAtMouse: " .. tostring(bodyAtMouse), 20, 40)
		love.graphics.print("dt: " .. love.timer.getDelta(), 20, 60)

		love.graphics.print("WheelLeftSpeed: " .. car.joints.leftWheelAxel.joint:getMotorSpeed(), 200, 20)
		love.graphics.print("WheelRightSpeed: " .. car.joints.rightWheelAxel.joint:getMotorSpeed(), 200, 40)
		love.graphics.print("ChassisAngVel: " .. car.bodies.chassis:getAngularVelocity(), 200, 60)
 
		love.graphics.translate(camX, camY)
        love.graphics.scale(camScale)
		
		love.graphics.setColor(255,255,255,40)
		
		--[[
		local gridW = 64
		local gridH = 64
		for yy=0, 8000, gridW do
		for xx=0, 8000, gridH do
			if xx > -camX/camScale - gridW/camScale and xx < -camX/camScale + 800/camScale + gridW/camScale then
			if yy > -camY/camScale - gridH/camScale and yy < -camY/camScale + 600/camScale + gridH/camScale then
				love.graphics.rectangle("line", xx, yy, gridW, gridH)
			end
			end
		end
		end
		]]--
 
	   bodyAtMouse = fizz.bodyAtPoint( vMouseX, vMouseY)
 
        fizz.drawAll(true, true, toggleCollisionDrawing)
		
		if toggleSpriteDrawing then
			car:draw()
			player:draw()
		end
 
        if bodyAtMouse and bodyAtMouse ~= focusedBody then
               bodyAtMouse:drawBound()
                if love.mouse.isDown("m") then
                        focusedBody = bodyAtMouse
                end
        end		
       
        if focusedBody then
                focusedBody:drawBound(true)
        end
		
		if love.mouse.isDown("l") and not mJoint and bodyAtMouse and bodyAtMouse:isDynamic() then
			mJoint = bodyAtMouse:newMouseJoint( vMouseX, vMouseY )
		end	
end
 
function love.keypressed(k)	
		if k == "escape" then
			love.event.push("q")
		end

        if k == " " then
                worldSimulate = not worldSimulate
        end
        if k == "m" then
                for i=0, 10 do
                local tb = world:newBody( 320, 300, 0, 0)
                tb:newCircleShape(0, 0, 3)
                tb:setMassFromShapes()
                end
        end
		
		if k == "lctrl" or k == "rctrl" then
			camNumber = camNumber + 1
			if camNumber > #camTargets then camNumber = 1 end
		end
		
		if k == "1" then
			toggleCollisionDrawing = not toggleCollisionDrawing
		end
		if k == "2" then
			toggleSpriteDrawing = not toggleSpriteDrawing
		end
end
 
function love.mousepressed(mousex, mousey, b)
        if b == "wu" then
                camScale= camScale + 0.1
				--camX = ( (camX ) / camScale ) - mousex / camScale
				--camY = ( (camY ) / camScale ) - mousey / camScale
				--camX = ( mousex / camScale + camX - mousex / (camScale) ) - (love.graphics.getWidth()/2 - mousex  )
				--camY = ( mousey / camScale + camY - mousey / (camScale) ) - (love.graphics.getHeight()/2 - mousey)
        end
        if b == "wd" then
                camScale = camScale - 0.1
				--[[camX = ( (camX ) / camScale ) - x
				camY = ( (camY ) / camScale ) - y   ]]--
				--camX = ( mousex / camScale + camX - mousex / (camScale) )
				--camY = ( mousey / camScale + camY - mousey / (camScale) )                             
				if camScale < 0.001 then camScale = 0.01 end
        end
		if not bodyAtPoint then
			
			if mJoint then
			mJoint:destroy()
			mJoint = nil
			end
			focusedBody = false
		end
end
 
function love.mousereleased(x, y, b)
end